Index: asterisk/asterisk.c
===================================================================
RCS file: /usr/cvsroot/asterisk/asterisk.c,v
retrieving revision 1.115
diff -u -r1.115 asterisk.c
--- asterisk/asterisk.c	8 Aug 2004 17:15:01 -0000	1.115
+++ asterisk/asterisk.c	12 Aug 2004 22:03:23 -0000
@@ -170,14 +170,24 @@
 	return write(fd, s, strlen(s) + 1);
 }
 
+static void sigchld_handler( int signal )
+{
+}
+
 int ast_safe_system(const char *s)
 {
 	/* XXX This function needs some optimization work XXX */
 	pid_t pid;
 	int x;
 	int res;
+#ifdef BSD
 	struct rusage rusage;
+#endif
 	int status;
+#ifndef BSD
+	/* Need to set SIGCHLD handler or else we might get ECHILD on own own process */
+	void (*prev_handler) = signal(SIGCHLD,sigchld_handler);
+#endif
 	pid = fork();
 	if (pid == 0) {
 		/* Close file descriptors and launch system command */
@@ -188,7 +198,11 @@
 		exit(1);
 	} else if (pid > 0) {
 		for(;;) {
+#ifdef BSD
 			res = wait4(pid, &status, 0, &rusage);
+#else
+			res = waitpid(pid, &status, 0);
+#endif
 			if (res > -1) {
 				if (WIFEXITED(status))
 					res = WEXITSTATUS(status);
@@ -204,6 +218,10 @@
 		ast_log(LOG_WARNING, "Fork failed: %s\n", strerror(errno));
 		res = -1;
 	}
+#ifndef BSD
+	/* Restore the signal handler */
+	signal(SIGCHLD,prev_handler);
+#endif
 	return res;
 }
 
